import java.util.Iterator;

/**
 * Klasse Warteschlange
 * 
 * @author claus albowski
 * @version Kursversion 4'11
 */
public class Warteschlange
{
    Listenelement kopf, schwanz; 

    /**
     * Konstruktor fuer Objekte der Klasse Warteschlange
     */
    public Warteschlange()
    {
        kopf=null;
        schwanz=null;
    }

    /**
     * ein Objekt stellt sich an.
     */
    public void anstellen(Object kunde){
        Listenelement neu =  new Listenelement(kunde);
        if (kopf==null) {
            kopf = neu;
            schwanz=neu;
        }
        else {
            schwanz.naechstes=neu;
            schwanz=neu;
        }
    }

    /**
     * bedienen laesst den ersten bearbeiten und
     * die Schlange aufruecken
     */
    public Object bedienen(){
        Object inhalt=null;
        if (!istLeer()) {
            inhalt=kopf.inhalt;
            kopf=kopf.naechstes;
            if (istLeer()) schwanz=null;
        }
        return inhalt;
    }

    /**
     * prueft, ob die Schlange leer ist.
     */
    public boolean istLeer(){
        return (kopf==null);
    }
    
    /**
     * gibt einen Iterator fuer die Warteschlange zurueck.
     */
    public Iterator iterator(){
        Iterator it = new Iterator(){
            Listenelement aktuell=kopf;
            /**
             * Returns true if the iteration has more elements. 
             * (In other words, returns true if next would return an element rather than throwing an exception.) 
             */
            public boolean hasNext(){
                return (aktuell != null);
            }
            
            /**
             * Returns the next element in the iteration. 
             */
            public Object next(){
                Object inhalt=aktuell.inhalt;
                aktuell=aktuell.naechstes;
                return inhalt;
            }
            
            /**
             * Removes from the underlying collection the last element returned by the iterator (optional operation).
             * ist daher nicht implementiert!
             */
            public void remove(){
            }
        };
        return it;
    }
    
    ///////////////////////////////////////////////////////////////////////////////////////////////
    /**
     * interne Klasse Listenelement
     */
    private class Listenelement
    {
        private Object inhalt;
        private Listenelement naechstes;

        /**
         * Konstruktor fuer Objekte der Klasse Listenelement
         */
        public Listenelement(Object inhalt)
        {
            this.inhalt=inhalt;
            naechstes=null;
        }
    }
}
